unit Calc_Matrix;

interface
uses
  Classes,SysUtils,Matrix;

procedure Calc(FileName:string);

implementation

procedure Calc(FileName:string);
var
  SL_Es,SL_E:TStringList;
  SimEquations:TSimultaneousEquations;
  Vector:TVector;
  i,j:Integer;
  d:Double;
begin
  SL_Es:=TStringList.Create;
  try
    if not FileExists(FileName) then
    begin
      Writeln(Format('%s¸ߤޤ',[FileName]));
      Exit;
    end;
    SL_Es.LoadFromFile(FileName);
    { եɤ߹ߴλ }
    SL_E:=TStringList.Create;
    { Ϥ줿ե뤬ξ }
    if SL_Es.Count<=0 then Exit;
    try
      SL_E.CommaText:=SL_Es[0];
      SimEquations:=TSimultaneousEquations.Create(StrToIntDef(SL_E[0],1));
      try
        if SimEquations.Order >= SL_Es.Count then
        begin
          Writeln('Ԥο­ޤ');
          Exit;
        end;
        for i:=1 to SimEquations.Order do
        begin
          SL_E.CommaText:=SL_Es[i];
          if SimEquations.Order > SL_E.Count then
          begin
            Writeln(Format('%dܤο­ޤ',[i-1]));
            Exit;
          end;
          for j:=0 to SimEQuations.Order do
          begin
            if TryStrToFloat(SL_E[j],d) then
            begin
              if j<SimEquations.Order then
                SimEquations.Coefficient.Component[i-1,j]:=d
              else
                SimEquations.Constant.Component[i-1]:=d;
            end
            else
            begin
              { ͰʳϤ줿(顼) }
              Writeln(Format('%d%dܤʬϿͤǤϤޤ',[i-1,j]));
              Exit;
            end;
          end;
        end;
        { ɤ߹ߴλ }
        { ٥ȥɤ߹ߴλ }
        { ϢΩ켡λ }
        Vector:=SimEquations.Solution;
        try
          { ٥ȥλ }
          if Vector<>nil then
          begin
            for i:=0 to Vector.CountofComponent-1 do
            begin
              Writeln(FloatToStr(Vector.Component[i]));
            end;
          end
          else
          begin
            { Ϥ줿ʤ(顼) }
            Writeln('Ϥ줿ϲ򤱤ޤ');
          end;
        finally
          Vector.Free;
        end;
      finally
        SimEquations.Free;
      end;
    finally
      SL_E.Free;
    end;
  finally
    SL_Es.Free;
  end;
end;

end.
